#include <iostream>
#include <fstream>
#include <map>
using namespace std;

const int MAXN = 100000;
const int MAXM = 500000;
const int MOD = 1000000007;
const int INV2 = 500000004;

class Edge
{
public:
	int be, en;
};

int n, m, t;
Edge edg[2 * MAXM];
int first[MAXN + 1];
int next[2 * MAXM];
int ist[MAXN + 1];
int nume;

void AddEdge(int v1, int v2)
{
	edg[nume].be = v1;
	edg[nume].en = v2;
	next[nume] = first[v1];
	first[v1] = nume;
	nume++;
}

void Load()
{
	memset(first, 0xFF, sizeof(first));
	memset(ist, 0, sizeof(ist));
	scanf("%d%d%d", &n, &m, &t);
	int i;
	for (i = 0; i < t; i++)
	{
		int p;
		scanf("%d", &p);
		ist[p] = 1;
	}
	nume = 0;
	for (i = 0; i < m; i++)
	{
		int p, q;
		scanf("%d%d", &p, &q);
		AddEdge(p, q);
		AddEdge(q, p);
	}
}

int odist, nump;
int q[MAXN + 1];
int hd, tl;
int dst[MAXN + 1];
int num[MAXN + 1];

void Bfs(int v)
{
	memset(dst, 0x7F, sizeof(dst));
	dst[v] = 0;
	num[v] = 1;
	hd = tl = 0;
	q[0] = v;
	int i;
	while (hd <= tl)
	{
		if (dst[q[hd]] > odist) break;
		if (ist[q[hd]] && q[hd] != v)
		{
			if (dst[q[hd]] < odist)
			{
				odist = dst[q[hd]];
				nump = num[q[hd]];
			}
			else if (dst[q[hd]] == odist)
			{
				nump += num[q[hd]];
				if (nump >= MOD) nump -= MOD;
			}
		}
	    for (i = first[q[hd]]; i != -1; i = next[i])
	    {
	    	if (dst[edg[i].en] > dst[q[hd]] + 1)
	    	{
	    		dst[edg[i].en] = dst[q[hd]] + 1;
	    		num[edg[i].en] = num[q[hd]];
	    		tl++;
	    		q[tl] = edg[i].en;
	    	}
	    	else if (dst[edg[i].en] == dst[q[hd]] + 1)
	    	{
	    		num[edg[i].en] += num[q[hd]];
				if (num[edg[i].en] >= MOD) num[edg[i].en] -= MOD;
	    	}
	    }
		hd++;
	}
}

void Solve()
{
	int i;
	odist = 0x7F7F7F7F;
	nump = 0;
	for (i = 1; i <= n; i++)
	{
		if (ist[i] == 0) continue;
		Bfs(i);
	}
	nump = (((long long)nump) * INV2) % MOD;
	cout << odist << " " << nump << "\n";
}

int main()
{
//	freopen("tpath.in", "rt", stdin);
//	freopen("tpath.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
